% DOPutMC2.m
function P = DOPutMC2(S0,X,r,T,sigma,Sb,NSteps,NRepl)
% Generate asset paths
[Call,Put] = blsprice(S0,X,r,T,sigma);
TotPayoff = 0;
for i=1:NRepl
   Path=AssetPaths1(S0,r,sigma,T,NSteps,1);
   crossed = any(Path <= Sb);
   if crossed == 0
      TotPayoff = TotPayoff + max(0, X - Path(NSteps+1));
   end
end
P = exp(-r*T) * TotPayoff / NRepl;