% DOPutMC3.m
function [Pdo,CI] = DOPutMC3(S0,X,r,T,sigma,Sb,NSteps,NRepl)
dt = T/NSteps;
[Call,Put] = blsprice(S0,X,r,T,sigma);
% Generate asset paths and payoffs for the down and in option
Payoff = zeros(NRepl);
for i=1:NRepl
   Path=AssetPaths1(S0,r,sigma,T,NSteps,1);
   tcrossed = min(find( Path <= Sb ));
   if isempty(tcrossed)
      payoff(i) = 0;
   else
      time = (tcrossed-1) * dt;
      [Caux,Paux] = blsprice(Path(tcrossed),X,r,T-time,sigma);
      payoff(i) = exp(-r*time) * Paux;
   end
end
[Pdo, aux, CI] = normfit(Put - payoff);