% DownOutPut.m
function PB = DownOutPut1(S0,X,r,T,sigma,Sb)
[C,P] = blsprice(S0,X,r,T,sigma);
lambda = (r+0.5*sigma^2)/sigma^2;
x1 = lambda*sigma*sqrt(T) + log(S0/Sb)/(sigma*sqrt(T));
y1 = lambda*sigma*sqrt(T) + log(Sb/S0)/(sigma*sqrt(T));
y = lambda*sigma*sqrt(T) + log(Sb^2/(S0*X))/(sigma*sqrt(T));
pdi = - S0* normcdf(-x1) + X*exp(-r*T)*normcdf(-x1+sigma*sqrt(T)) + ...
   S0*(Sb/S0)^(2*lambda)*(normcdf(y) - normcdf(y1)) - ...
   X*exp(-r*T)*(Sb/S0)^(2*lambda-2)*(normcdf(y - sigma*sqrt(T)) - ...
   normcdf(y1 - sigma*sqrt(T)));
PB = P - pdi;

